# Commerce CMI

## Introduction

Commerce CMI is a Drupal module that integrates the CMI (Centre Monétique
Interbancaire) payment gateway with Drupal Commerce. This module allows you to
accept payments through CMI in your Drupal Commerce store.

## Requirements

- Drupal 9 or 10
- Drupal Commerce 2.x or 3.x
- PHP 7.4 or higher

## Installation

1. Download the module and place it in your `modules/contrib` directory.
2. Enable the module using Drush: `drush en commerce_cmi` or through the Drupal
admin interface.

## Configuration

1. Go to Admin > Commerce > Configuration > Payment gateways.
2. Click "Add payment gateway".
3. Select "CMI" as the plugin.
4. Fill in the required fields:
  - Client ID: Your CMI client ID
  - Store Key: Your CMI store key
  - API URL: The URL for the CMI payment gateway API
5. Save the configuration.

## Usage

Once configured, CMI will appear as a payment option during checkout. Customers
will be redirected to the CMI payment page to complete their payment.

## Customization

The module provides several fields that are sent to the CMI API. If you need to
modify these fields or add additional ones, you can extend
the `CmiOffsiteForm` class in your custom module.

## Callback Handling

The module sets up a callback URL to handle responses from CMI.
Ensure that this URL is accessible from the internet and properly
handles incoming requests.

## Troubleshooting

- If you encounter issues with payments not being processed, check the Drupal
logs for any error messages.
- Ensure that your CMI credentials (Client ID and Store Key) are correct.
- Verify that the API URL is correct for your environment (test or production).
- Check that the callback URL is accessible and properly configured in
your CMI account.

## Support

For bug reports and feature requests, please use the [issue queue](https://www.drupal.org/project/issues/commerce_cmi) on Drupal.org.

## Contributing

Contributions to the module are welcome! Please follow [Drupal coding standards](https://www.drupal.org/docs/develop/standards)
when submitting patches or pull requests.

## Security Considerations

- Never store sensitive payment information in your Drupal database.
- Ensure that your website is using HTTPS to encrypt all communications.
- Regularly update Drupal core, contributed modules, and this module to ensure
you have the latest security fixes.

## License

This module is licensed under the GNU General Public License v2.0 or later.
